<?php
/**
 * Created by JetBrains PhpStorm.
 * User: Valery Stukanov
 * Date: 10/21/11
 * Time: 1:17 PM
 */

/**
 * @param string $settings
 * @return array
 */
function parse_order_setting($settings) {
	$done = false;
	$result = array();
	$place_holders = explode('|', $settings);
	foreach($place_holders as $holder_txt) {
		list($place_holder, $order_text) = explode('=', $holder_txt);
		$result[$place_holder] = explode(',', $order_text);
		foreach($result[$place_holder] as $key => $widget) {
			if($widget === 'widget-geomap') {
				$result[$place_holder][$key] = 'widget-geomap2';
				$done = true;
			}
		}
	}
	return array($done, $result);
}

/**
 * @param array $settings
 * @return string
 */
function encode_order_setting($settings) {
	$result = '';
	foreach($settings as $place_holder => $widgets) {
		$result .= "$place_holder=" . implode(',', $widgets) . "|";
	}
	return rtrim($result, '|');
}

$dbh = new PDO('mysql:host=localhost;dbname=merlin', 'root', NULL, array(PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES utf8"));
$stmt = $dbh->query("SELECT `id`, `setting` FROM `ninja_settings` WHERE `type` = 'widget_order'");
$data = $stmt->fetchAll(PDO::FETCH_ASSOC);
$update = $dbh->prepare("UPDATE `ninja_settings` SET `setting` = :setting WHERE `id` = :id;");

foreach($data as $key => $setting) {
	list($done, $result) = parse_order_setting($setting['setting']);
	if(!$done) {
		array_unshift($result["widget-placeholder"], "widget-geomap2");
	}
	$update->execute(array('id' => $setting['id'], 'setting' => encode_order_setting($result)));
};
?>