<?php defined('SYSPATH') OR die('No direct access allowed.');
if (!isset($is_widget)) $is_widget = false;
?>

<script type="text/javascript">
var base_url = '<?php echo url::base(); ?>';
var cloudmade_key = '<?php echo isset($settings['cloudmadeKey']) ? $settings['cloudmadeKey'] : ''; ?>';
var local_maps = '<?php echo isset($settings['localMapsUrl']) ? $settings['localMapsUrl'] : ''; ?>';
var edit_mode = <?php echo $edit_mode ? 'true' : 'false'; ?>;
var update_interval = <?php echo $interval = isset($settings['updateInterval']) ? $settings['updateInterval']
		: '400'; ?>;
var version = <?php $v = isset($settings['version']) ? $settings['version'] : "2.0"; printf('"%.1f"', (float) $v) ?>;
var locations = {};
var links = {};
var prev_location;
var location_dialog;
var link_dialog;
var hosts_html = '';
var services_html = '';
var hostgroups_html = '';
var servicegroups_html = '';
var is_open = false;

function array2hash(ary) {
	var hash = {};

	for (var i in ary)
		hash[ary[i].id] = ary[i];

	return hash;
}

function update(types, callback) {
	if (!types)
		types = ['locations', 'links']
	// trigger link & location updating in parallel
	// this should make reloads look faster
	var cb = trigger_cb_on_nth_call(function() {
		geomap.clear();
		geomap.populate(locations, links);
		if (callback)
			callback();
		if (edit_mode) {
			if (!hosts_html) {
				$.getJSON(base_url + 'index.php/geomap/hosts', function(data) {
					hosts_html = '';
					for (var i = 0; i < data.length; i++)
						hosts_html += '<option value="' + data[i] + '">' + data[i] + '</option>';
				});
			}
			if (!services_html) {
				$.getJSON(base_url + 'index.php/geomap/services', function(data) {
					services_html = '';
					for (var i = 0; i < data.length; i++)
						services_html += '<option value="' + data[i] + '">'
								+ data[i] + '</option>';
				});
			}
			if (!hostgroups_html) {
				$.getJSON(base_url + 'index.php/geomap/hostgroups', function(data) {
					hostgroups_html = '';
					for (var i = 0; i < data.length; i++)
						hostgroups_html += '<option value="' + data[i] + '">' + data[i] + '</option>';
				});
			}
			if (!servicegroups_html) {
				$.getJSON(base_url + 'index.php/geomap/servicegroups', function(data) {
					servicegroups_html = '';
					for (var i = 0; i < data.length; i++)
						servicegroups_html += '<option value="' + data[i] + '">' + data[i] + '</option>';
				});
			}
		}
	}, types.length);
	for (var i in types) {
		(function(){
			var j = i;
			$.getJSON(base_url + 'index.php/geomap/'+types[j], function(data) {
				$('#page_last_updated').html(data.updated);
				window[types[j]] = array2hash(data.items);
				cb();
			});
		})();
	}
}
(function($){
	$.fn.extend({
		highLight: function(options) {

			var defaults = {
				errorColor: '#D96262',
				defaultColor: '#CDCDDC'
			};

			var options = $.extend(defaults, options);

			$(this).bind("alert", function() {
				$(this).css('outline-color', options.errorColor);
				setTimeout( (function(node) { return function() { $(node).css("outline-color", options.defaultColor); $(node).trigger("focus"); } })(this), 1000 );
			});
		}
	});
})(jQuery);

$(document).ready(function() {
	if(typeof(window._widget_template) === "undefined") {
		$('#refresh').unbind('click').bind('click', function() { update.call(); });
	} else {
		setTimeout(function(){ $("#map").attr({ style: null }); }, 300);
	}
	$('#version_info li').html(('Geomap ').concat(version.toString(), ' on ', $('#version_info li').html()));
	$('#geomap-refresh').slider({
		value: update_interval,
		min: 10,
		max: 500,
		step: 10,
		slide: function(e, ui) {
			$('#geo-refresh-rate').val(parseInt(ui.value));
		}
	});
	$('#geomap_settings')
		.bind('click', function(e) {
			$('#geomap-settings').show();
			e.preventDefault();
		});
	if ($('#local_maps_url').val() == '')
		$('#local_maps_url').val(window.location.protocol + '//' + window.location.host);
	$('#local_maps_url').highLight();
	$('#geomap-settings')
		.bind('click', function(e) {
			e.stopPropagation();
		})
		.find('form')
			.submit(function(ev) {
				ev.preventDefault();
				var save_func = function(data) {
					$.ajax({
						type: 'get',
						url: base_url + 'index.php/geomap/savesettings',
						data: data,
						dataType: 'json',
						success: function(res) { window.location.reload(); }
					});
				};
				var data = { 'provider': $('#geo-provider', this).val() };
				if (data['provider'] === 'osm') {
					data['cloudmadeKey'] = $('#cloudmadeKey').val();
				}
				if (data['provider'] === 'local') {
					data['localMapsUrl'] = $('#local_maps_url', this).val();
					if(data['localMapsUrl'][data['localMapsUrl'].length - 1] === "/") 
						data['localMapsUrl'] = data['localMapsUrl'].slice(0, -1);
					$("<img style=\"display: none\" src=\"%%URL%%\"></img>".replace("%%URL%%", data['localMapsUrl'] + "/0/0/0.png"))
						.appendTo(document.body)
						.bind(
							"load",
							{d: data},
							function(e) {
								save_func(e.data.d);
								$(this).remove();
							}
						)
						.bind(
							"error",
							function() {
								$('#local_maps_url').triggerHandler("alert");
								$("#geomap_settings").trigger("click");
								$(this).remove();
							});
					return;
				}
				data['updateInterval'] = $('#geomap-refresh').slider("option", "value");
				save_func(data);
			})
			.find('button.cancel')
				.click(function(ev) {
					ev.preventDefault();
					$('#geomap-settings').hide();
				});
	$('#geo-provider').bind('change', function() {
		var settings = $(this).parents('#geomap-settings');
		settings.find('#geo-code')[$(this).val() == 'osm' ? 'show' : 'hide']();
		settings.find('#geo-local')[$(this).val() == 'local' ? 'show' : 'hide']();
	});
	// Save map center and zoom on update or change view mode
	var view_position;
	if (typeof(window['localStorage']) !== 'undefined') {
		var position = localStorage['op5.geomap.view_position'];
		if (typeof(position) !== 'undefined') {
			view_position = JSON.parse(position);
		}
		$(window).unload(function() {
			window.localStorage['op5.geomap.view_position'] = JSON.stringify(geomap.getViewPoint());
		});
	}
	location_dialog = $('#location_dialog').dialog({
		autoOpen: false,
		// modal: true, // does not work for map
		resizable: false,
		closeText: '',
		width: 500,
		title: 'Edit location'
	});
	$('#location_dialog input[type=reset]').click(function() {
		$(location_dialog).dialog('close');
	});
	link_dialog = $('#link_dialog').dialog({
		autoOpen: false,
		// modal: true, // does not work for map
		resizable: false,
		closeText: '',
		title: 'Edit link'
	});
	$('#link_dialog input[type=reset]').click(function() {
		$(link_dialog).dialog('close');
	});
	var default_view = {
		center: [51.505, -0.09],
		zoom: 5
	};
	var pos = $.extend(default_view, view_position);
	if(geomap.type === "leaflet") {
		pos["cloudmade_key"] = cloudmade_key;
	}
	if(geomap.type === "local") {
		pos["local_maps_url"] = local_maps;
	}
	$('#map').bind('adjust', function() {
		$(this).height($(window).height() - ($(this).offset())['top']);
	});
	$('#map').triggerHandler('adjust');
	$(window).resize(function() {
		$('#map').triggerHandler('adjust');
	});
	geomap.init($.extend({
		base_url: base_url,
		edit_mode: edit_mode,
		iframe_mode: typeof(window['_widget_template']) !== 'undefined' && _widget_template
	}, pos));
	$('.object_type').bind('change', function() {
		var object_type = $(this);
		var dl = object_type.parent().parent();
		var object_name = dl.find('.object_name');
		var hidden_containers = dl.find('.hidden, .object_name');
		switch (object_type.val()) {
			case 'host':
				object_name.html(hosts_html);
				hidden_containers.show();
				break;

			case 'service':
				object_name.html(services_html)
				hidden_containers.show();
				break;

			case 'hostgroup':
				object_name.html(hostgroups_html)
				hidden_containers.show();
				break;

			case 'servicegroup':
				object_name.html(servicegroups_html)
				hidden_containers.show();
				break;

			default:
				hidden_containers.hide();
		}
	});
	$('#location_form').submit(function() {
		var type = $(this).data('type');
		if (type !== 'add')
			type = 'edit';
		$(this).ajaxSubmit({
			url: base_url + 'index.php/geomap/'+type+'_location/',
			beforeSubmit: function(data, form, options) {
				switch ($('#location_object_type').val()) {
					case 'host':
					case 'hostgroup':
					case 'servicegroup':
						data.push({name: 'object_type', value: $('#location_object_type').val()});
						data.push({name: 'object_name', value: $('#location_object_name').val()});
						break;
					case 'service':
						var service = $('#location_object_name').val().split(';');
						data.push({name: 'object_type', value: $('#location_object_type').val()});
						data.push({name: 'object_host', value: $.trim(service[0])});
						data.push({name: 'object_description', value: $.trim(service[1])});
				}
				return true;
			},
			success: function() {
				update(['locations'], function() {
					$(location_dialog).dialog('close');
				});
			}
		});
		return false;
	});
	$('#link_form').ajaxForm({
		url: base_url + 'index.php/geomap/edit_link/',
		beforeSubmit: function(data, form, options) {
			switch ($('#link_object_type').val()) {
				case 'host':
				case 'hostgroup':
				case 'servicegroup':
					data.push({name: 'object_type', value: $('#link_object_type').val()});
					data.push({name: 'object_name', value: $('#link_object_name').val()});
					break;
				case 'service':
					var service = $('#link_object_name').val().split(';');
					data.push({name: 'object_type', value: $('#link_object_type').val()});
					data.push({name: 'object_host', value: $.trim(service[0])});
					data.push({name: 'object_description', value: $.trim(service[1])});
			}
			return true;
		},
		success: function() {
			update(['links'], function() {
				$(link_dialog).dialog('close');
			});
		}
	});
	geomap.onDetails = function(object) {
		switch (object.type) {
			case 'host':
				return base_url + 'index.php/status/service/?name=' + encodeURIComponent(object.name);
			case 'service':
				return base_url + 'index.php/extinfo/details/?type=service&host=' + encodeURIComponent(object.host) + '&service=' + encodeURIComponent(object.description);
			case 'hostgroup':
				return base_url + 'index.php/status/hostgroup/?group=' + encodeURIComponent(object.name);
			case 'servicegroup':
				return base_url + 'index.php/status/servicegroup/?group=' + encodeURIComponent(object.name) + '&style=detail';
			default:
				return '#';
	 	}
	};
	geomap.onAddLocation = function(coords) {
		$(location_dialog).dialog('option', 'title', 'Add location').find('#location_form').data('type', 'add');
		geomap.showLocationDialog({point: coords, label: 'New location'});
	};
	geomap.onLink = function(id) {
		var location = locations[id];
		if (prev_location) {
			if (prev_location.id == location.id)
				alert('You cannot link location to itself');
			else {
				for (var i in links) {
					var link = links[i];
					if (link.id1 == prev_location.id && link.id2 == location.id
							|| link.id1 == location.id && link.id2 == prev_location.id) {
						alert('Link between "' + prev_location.label + '" and "' + location.label + '" already exists');
						prev_location = undefined;
						return;
					}
				}

				$('#hintbar').hide().html('');
				$.post(base_url + 'index.php/geomap/add_link/', {id1: prev_location.id, id2: location.id}, function() {
					/* note: delete does not work! */
					prev_location = undefined;
					update(['links']);
				});
			}
		}
		else {
			$('#hintbar').html('Location linking started. Now select another location and click "Link". &nbsp; &nbsp; '
					+ '<a href="#" onclick="prev_location = undefined; $(\'#hintbar\').html(\'\'); return false;">Cancel</a>').show();
			prev_location = location;
		}
	};
	geomap.onEditLocation = function(id) {
		$(location_dialog).dialog('option', 'title', 'Edit location').find('#location_form').data('type', 'edit');
		geomap.showLocationDialog(locations[id]);
	};
	geomap.showLocationDialog = function(location) {
		$(location_dialog).dialog('open');
		$('#location_id').val(location.id);
		$('#location_point').val(location.point);
		$('#location_label').val(location.label);
		$('#location_address').val(location.address ? location.address : '');
		$('#location_description').val(location.description ? location.description : '');
		if (location.object) {
			$('#location_object_type').val(location.object.type);
			$('#location_object_type').trigger('change');
			if (location.object.name)
				$('#location_object_name').val(location.object.name);
			else if (location.object.host && location.object.description)
				$('#location_object_name').val(location.object.host + ';' + location.object.description);
		} else {
			$('#location_object_type').val('none');
			$('#location_object_type').trigger('change');
		}
	}
	geomap.onEditLink = function(id) {
		var link = links[id];
		$(link_dialog).dialog('open');
		$('#link_id').val(link.id);
		$('#link_id1').val(link.id1);
		$('#link_id2').val(link.id2);
		$('#link_description').val(link.description ? link.description : '');
		if (link.object)
			$('#link_object_type').val(link.object.type);
		else
			$('#link_object_type').val('none');
		$('#link_object_type').trigger('change');
	};
	geomap.onRemoveLocation = function(id) {
		var location = locations[id];
		if (confirm('Remove location "' + location.label + '"?')) {
			for (var i in links) {
				var link = links[i];
				if (id == link.id1 || id == link.id2)
					$.post(base_url + 'index.php/geomap/remove_link/', {id: link.id});
			}

			$.post(base_url + 'index.php/geomap/remove_location/', {id: location.id}, function() {
				update();
			});
		}
	};
	geomap.onRemoveLink = function(id) {
		var link = links[id];
		if (confirm('Remove link "' + link.description + '"?')) {
			$.post(base_url + 'index.php/geomap/remove_link/', {id: link.id}, function() {
				update(['links']);
			});
		}
	};
	geomap.onCancel = function() {
		geomap.closeNew();
	};
	update();
	if (edit_mode) {
		$('#search_form').bind('submit', function() {
			geomap.search($('#search_text').val(), function(markers) {
				geomap.showSearchMarkers(markers);
			});
		});
	}
	else
		setInterval(update, update_interval * 1000);
});
</script>
<style type="text/css">
	#search_form {
		float: right;
	}

	#search_text {
		width: 238px;
		margin: 5px 4px;
		padding: 3px 5px 4px 27px;
		font: 11px arial, sans-serif;
		color: #414141;
		background: transparent url(<?php echo url::base(); ?>application/views/css/default/images/input-270.png) no-repeat;
		border: none
		outline: none;
	}

	#geomap-settings {
		position: fixed;
		top: 67px;
		padding: 0;
		border: 1px solid #E9E9E0;
		background-color: #F5F5EF;
		display: none;
		z-index: 10000;
		width: auto;
	}

	#geomap-settings ul>li {
		background: #E0E0E0 url(<?php echo url::base(); ?>application/views/css/default/images/bg.png) repeat-x;
		list-style: none;
		border-bottom: 1px solid #E9E9E0;
		padding: 5px 10px;
		width: 200px;
		position: relative;
	}

	#geomap-settings ul>li input,
	#geomap-settings ul>li button {
		width: 188px;
	}

	#geomap-settings ul>li select {
		width: 200px;
	}

	#geomap-settings ul>li.menu-header {
		font-weight: bold;
		padding-top: 15px;
	}

	#geomap-settings ul>li #geo-refresh-rate {
		position: absolute;
		top: 5px;
		right: 8px;
		width: 41px;
		height: 14px;
		font-size: 11px;
	}

	#geomap-settings ul>li #geomap-refresh {
		margin-top: 10px;
	}

	#location_form input, #location_form select {
		width: 90%;
	}
<?php if($is_widget){ ?>
	#map {
		position: fixed;
		top: 0; left: 0; right: 0; bottom: 0;
	}
<?php } ?>
</style>
<?php if(!$is_widget){ ?>
<div id="page_links">
	<em class="page-links-label">Geomap sections</em>
	<ul>
		<li><?php echo $edit_mode ? '<strong>Edit</strong>'
				: html::anchor(url::current() . '?edit', 'Edit'); ?></li>
		<li><?php echo !$edit_mode ? '<strong>View</strong>'
				: html::anchor(url::current(), 'View'); ?></li>
		<li><a href="#" id='geomap_settings'>Settings</a></li>
	</ul>
	<div class="clear"></div>
	<hr>
</div>
<?php } ?>
<div id="geomap">
	<div id="map-menu">
		<?php if ($edit_mode) { ?>
		<form id="search_form" onsubmit="return false;">
			<input type="text" id="search_text"/>
			<input type="submit" value="Search"/>
		</form>
		<p id="hintbar">Double click to add a location. In that form, you have free hands to manually enter a locations latitude &amp; longitude.</p>
		<?php } ?>
	</div>
	<div id="map" style="clear: both; width: 100%; height: 700px;"></div>
</div>
<div id="location_dialog" style="display: none">
        <form id="location_form" action="#" method="POST">
                <input id="location_id" name="id" type="hidden" value=""/>
                <dl class="listing_form_elements">
                        <dt><label for="location_label">Label:</label></dt>
			<dd style="float: none; clear: both">
                                <input id="location_label" name="label" type="text" value="" />
                        </dd>

                        <dt><label for="location_address">Address:</label></dt>
			<dd style="float: none; clear: both">
                                <input id="location_address" name="address" type="text" value="" />
                        </dd>

                        <dt><label for="location_description">Description:</label></dt>
			<dd style="float: none; clear: both">
                                <input id="location_description" name="description" type="text" value="" />
                        </dd>

                        <dt><label for="location_point">Latitude,longitude:</label></dt>
			<dd style="float: none; clear: both">
				<input id="location_point" name="point" type="text" value=""/>
                        </dd>

                        <dt><label for="location_object_type">Object type:</label></dt>
			<dd style="float: none; clear: both">
                                <select id="location_object_type" class="object_type">
                                        <option value="none">None</option>
                                        <option value="host">Host</option>
                                        <option value="service">Service</option>
                                        <option value="hostgroup">Hostgroup</option>
                                        <option value="servicegroup">Servicegroup</option>
                                </select>
                        </dd>

                        <dt class="hidden"><label for="location_object_name">Object name:</label></dt>
                        <dd style="float: none; clear: both" class="hidden">
                                <select id="location_object_name" class="object_name"></select>
                        </dd>

                        <dt></dt>
                        <dd style="float: none; clear: both" class="hidden">
				<p>
					<input type="submit" value="Save"/>
					<input type="reset" value="Cancel"/>
				</p>
			</dd>
		</dl>
        </form>
</div>
<div id="link_dialog" style="display: none">
	<form id="link_form" action="#" method="POST">
		<input id="link_id" name="id" type="hidden" value=""/>
		<input id="link_id1" name="id1" type="hidden" value=""/>
		<input id="link_id2" name="id2" type="hidden" value=""/>
		<label for="link_description">Description:</label>
		<input id="link_description" name="description" type="text" value=""/><br/>
		<label for="link_object_name">Object:</label>
		<select id="link_object_type" class="object_type">
			<option value="none">None</option>
			<option value="host">Host</option>
			<option value="service">Service</option>
			<option value="hostgroup">Hostgroup</option>
			<option value="servicegroup">Servicegroup</option>
		</select>
		<select id="link_object_name" class="object_name hidden">
		</select><br/>
		<input type="submit" value="Save"/>
		<input type="reset" value="Cancel"/>
	</form>
</div>
<div style="display: none" id="geomap-settings" class="page_settings">
	<form action="#">
		<ul>
			<li class="menu-header">Geomap Settings</li>
			<li>
				<label for="geo-provider" class="hidden">Provider</label>
				<select name="geo-provider" id="geo-provider">
					<option value="google"<?php if($settings["provider"] == "google") print " selected "; ?>>Google Map</option>
					<option value="osm"<?php if($settings["provider"] == "osm") print " selected "; ?>>Cloud Made</option>
					<option value="local"<?php if($settings["provider"] == "local") print " selected "; ?>>OpenStreetMap</option>
				</select>
			</li>
			<li id="geo-code" <?php if ($settings['provider'] != 'osm') print 'style="display:none;"'; ?>>
				<label>CloudMade key
					<input
						type="text"
						id="cloudmadeKey"
						name="cloudmadeKey"
						value="<?php print isset($settings['cloudmadeKey']) ? $settings['cloudmadeKey'] : ''; ?>"
						/>
				</label>
			</li>
			<li id="geo-local" <?php if ($settings['provider'] != 'local') print 'style="display:none;"'; ?>>
				<label>URL to local maps
					<input type="text" id="local_maps_url" name="local_maps_url" value="<?php print isset($settings['localMapsUrl']) ? $settings['localMapsUrl'] : ''; ?>"/>
				</label>
			</li>
			<li>
				<label for="geo-refresh-rate" id="geomap-refresh-title">Geomap refresh rate</label>
				<input type="text" id="geo-refresh-rate" value="<?php print $interval ?>"/>

				<div id="geomap-refresh"></div>
			</li>
			<li>
				<input type="submit" value="<?php echo _("Save"); ?>" /><br />
				<button class="cancel"><?php echo _("Cancel"); ?></button>
			</li>
		</ul>
	</form>
</div>
