<?php defined('SYSPATH') OR die('No direct access allowed.');
$current_skin = false;
$authorized = false;
if (Auth::instance()->logged_in()) {
	$ninja_menu_setting = Ninja_setting_Model::fetch_page_setting('ninja_menu_state', '/');

	$auth = op5auth::instance();
	if ($auth->authorized_for('host_view_all')) {
		$authorized = true;
	}

	# fetch info on current skin
	$current_skin = config::get('config.current_skin', '*', true);
	if (!substr($current_skin, -1, 1) != '/') {
		$current_skin .= '/';
	}
}
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
		<meta http-equiv="X-UA-Compatible" content="IE=8" /> <!-- Please remove me -->
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<link type="text/css" rel="stylesheet" href="<?php echo ninja::add_path('css/'.$current_skin.'common.css') ?>" media="screen" />
		<link type="text/css" rel="stylesheet" href="<?php echo ninja::add_path('css/'.$current_skin.'print.css') ?>" media="print" />
		<?php if (Router::$controller == 'status') { ?>
		<link type="text/css" rel="stylesheet" href="<?php echo ninja::add_path('css/default/jquery-ui-custom.css') ?>" />
		<?php } ?>
		<link type="image/icon" rel="icon" href="<?php echo ninja::add_path('icons/16x16/favicon.ico'); ?>" />
		<!--[If IE]>
		<link type="text/css" rel="stylesheet" href="<?php echo ninja::add_path('css/default/ie7.css') ?>" />
		<?php echo (Router::$controller.'/'.Router::$method == 'histogram/generate') ? html::script('application/media/js/excanvas.compiled.js') : ''; ?>
		<![endif]-->
		<?php
			$use_contextmenu = false;
			echo new View('css_header', array('css' => isset($css)?$css:array()));
			echo html::script('application/media/js/jquery.js');
			echo html::script('application/media/js/jquery-ui.min.js');
			echo html::script('application/media/js/jquery.form.js');
			echo html::script('application/media/js/jquery.easywidgets.min.js');
			echo html::script('application/media/js/jquery.autocomplete.min');
			echo html::script('application/media/js/jquery.selectboxes.min.js');
			echo html::script('application/media/js/jquery.jeditable.min');
			echo html::script('application/media/js/jquery.query.js');
			echo html::script('application/media/js/jquery.jgrowl.js');
			echo html::script('application/media/js/jquery.hotkeys.min.js');
			if (Router::$controller == 'status') {
				$use_contextmenu = true;
				# only required for status controller so no need to always include it
				echo html::script('application/media/js/jquery.contextMenu.js');
			}
			if (!isset($disable_refresh) || $disable_refresh === false) {
				refresh::control();
			}
		?>

		<script type="text/javascript">
			//<!--
			<?php
				if (Auth::instance()->logged_in()) { ?>
				var _site_domain = '<?php echo Kohana::config('config.site_domain') ?>';
				var _index_page = '<?php echo Kohana::config('config.index_page') ?>';
				var _current_uri = '<?php echo Router::$controller.'/'.Router::$method ?>';
				var _widget_refresh_msg = '<?php echo _('Refresh rate for all widgets has been updated to %s sec'); ?>';
				var _widget_refresh_error = '<?php echo _('Unable to update refresh rate for all widgets.'); ?>';
				var _widget_global_refresh_error = '<?php echo _('An error was encountered when trying to update refresh rate for all widgets.'); ?>';
				var _widget_order_error = '<?php echo _('Unable to fetch widget order from database.'); ?>';
				var _widget_settings_msg = '<?php echo _('Settings for widget %s was updated'); ?>';
				var _widget_settings_error = '<?php echo _('Unable to fetch setting for widget %s'); ?>';
				var _widget_notfound_error = '<?php echo _('Unable to find widget %s'); ?>';
				var _page_refresh_msg = '<?php echo _('Updated page refresh rate to %s seconds'); ?>';
				var _settings_msg = '<?php echo _('The settings were updated'); ?>';
				var _success_header = '<?php echo _('Success'); ?>';
				var _error_header = '<?php echo _('ERROR'); ?>';
				var _ninja_menu_state = '<?php echo 0 ?>';
				var _ninja_menusection_About = '<?php echo config::get('ninja_menusection_About', '/', false, true) ?>';
				var _ninja_menusection_Monitoring = '<?php echo config::get('ninja_menusection_Monitoring', '/', false, true) ?>';
				var _ninja_menusection_Reporting = '<?php echo config::get('ninja_menusection_Reporting', '/', false, true) ?>';
				var _ninja_menusection_Configuration = '<?php echo config::get('ninja_menusection_Configuration', '/', false, true) ?>';
				var _form_error_header = '<?php echo _("The form couldn\'t be processed since it contains one or more errors.%sPlease correct the following error(s) and try again:%s"); ?>';
				var _command_empty_field = '<?php echo _("Field \'%s\' is required but empty"); ?>';
				var _loading_str = '<?php echo _("Loading..."); ?>';
				var _wait_str='<?php echo _('Please wait') ?>';
				var _refresh_paused_msg='<?php echo _('Page refresh has been paused.') ?>';
				var _refresh_unpaused_msg='<?php echo _('Page refresh has been restored.') ?>';
				var _use_contextmenu=<?php echo $use_contextmenu === true ? 1 : 0; ?>;
				var _reports_link='<?php echo Kohana::config('reports.reports_link') ?>';
				var _widget_template=true;
			<?php	if (config::get('keycommands.activated', '*', true)) {	?>

					var _keycommands_active='<?php echo config::get('keycommands.activated', '*', true); ?>';
					var _keycommand_search='<?php echo config::get('keycommands.search', '*', true); ?>';
					var _keycommand_pause='<?php echo config::get('keycommands.pause', '*', true); ?>';
					var _keycommand_forward='<?php echo config::get('keycommands.forward', '*', true); ?>';
					var _keycommand_back='<?php echo config::get('keycommands.back', '*', true); ?>';
			<?php 	} else { ?>
					var _keycommands_active='0';
			<?php 	} ?>

				var _popup_delay='<?php echo config::get('config.popup_delay', '*', true); ?>';
				<?php
					if (!empty($js_strings)) {
						echo $js_strings;
					}
				}
				if (!empty($inline_js)) {
					echo "$(document).ready(function() {";
					echo $inline_js;
					echo "});";
				}?>
			//-->
		</script>
		<?php echo html::script('application/views/js/common.js'); ?>
		<?php echo new View('js_header', array('js' => isset($js)?$js:array())); ?>

	</head>

	<body>
		<div<?php echo (isset($nacoma) && $nacoma == true) ? ' class="ie7conf"' : ''?>>

			<?php if (isset($content)) { echo $content; } else { url::redirect('tac'); }?>
			<!--<p>Rendered in {execution_time} seconds, using {memory_usage} of memory</p> -->
		</div>
	</body>
</html>
